/// <reference types="node" />
import { ReadStream } from "fs";
import { Response } from "request";
import { CLIArgs } from "../CLI";
import { HTTPRequestHeaders, HTTPRequestMethod } from "../util/http";
import { Service } from "./Service";
interface GlacierAPIRequest {
    method: HTTPRequestMethod;
    subpath: string;
    headers: HTTPRequestHeaders;
    body?: {
        data: ReadStream | string;
        SHA256: string;
    };
}
export interface AWSS3GlacierOptions {
    region: string;
    accessId: string;
    secretKey: string;
    vaultName: string;
}
export declare const parseAWSS3GlacierOptions: (args: CLIArgs) => AWSS3GlacierOptions;
export interface AWSS3GlacierState {
    readonly requester: (request: GlacierAPIRequest) => Promise<Response>;
    readonly vaultName: string;
}
export declare const AWSS3Glacier: Service<AWSS3GlacierOptions, AWSS3GlacierState>;
export {};
