/// <reference types="node" />
import fs from "fs";
import request from "request";
export declare type HTTPRequestMethod = "HEAD" | "GET" | "POST" | "PUT" | "DELETE";
export declare type HTTPRequestQueryParameterValue = boolean | string | number;
export declare type HTTPRequestQueryParameters = {
    [query: string]: HTTPRequestQueryParameterValue;
};
export declare type HTTPRequestHeaders = {
    [header: string]: string | number;
};
export interface HTTPRequest {
    method: HTTPRequestMethod;
    url: string;
    headers: HTTPRequestHeaders;
    body?: string | fs.ReadStream | Buffer;
}
export declare class HTTPBadStatusError extends Error {
    readonly statusCode: number;
    constructor(status: number, body: any, url: string);
}
export declare const getLastHeaderValue: (res: request.Response, name: string) => string;
export declare const http: ({ method, url, headers, body, }: HTTPRequest) => Promise<request.Response>;
